---------------------------
--- Core Addon Creation ---
---------------------------
local tomQuest2 = LibStub("AceAddon-3.0"):NewAddon("tomQuest2", "AceEvent-3.0", "AceHook-3.0")
tomQuest2.cbh = LibStub("CallbackHandler-1.0"):New(tomQuest2)
_G["tomQuest2"] = tomQuest2

-----------------------
--- Library loading ---
-----------------------
tomQuest2.LC = LibStub("AceLocale-3.0"):GetLocale("tomQuest2-Core")
local LibTourist = LibStub("LibTourist-3.0")
tomQuest2.LBF = LibStub("LibButtonFacade", true)

--------------------------------------
--- Copy global functions to local ---
--------------------------------------
local pairs, next, type, GetTime, sort, floor, mod, tconcat, tremove, wipe = pairs, next, type, GetTime, table.sort, floor, mod, table.concat, tremove, wipe
local tonumber, format, gsub, strtrim, find, match, len, sub, time, strsplit = tonumber, string.format, string.gsub, strtrim, string.find, string.match, string.len, string.sub, time, strsplit
local GetDailyQuestsCompleted, GetQuestGreenRange, QuestDifficultyColors = GetDailyQuestsCompleted, GetQuestGreenRange, QuestDifficultyColors
local GetQuestLogLeaderBoard, GetQuestLogQuestText, GetQuestLogPushable = GetQuestLogLeaderBoard, GetQuestLogQuestText, GetQuestLogPushable
local GetQuestLogSelection, SelectQuestLogEntry, GetQuestLogTimeLeft, LoadAddOn = GetQuestLogSelection, SelectQuestLogEntry, GetQuestLogTimeLeft, LoadAddOn
local GetQuestLogRewardTalents, GetQuestLogRewardMoney, GetQuestLogRewardHonor = GetQuestLogRewardTalents, GetQuestLogRewardMoney, GetQuestLogRewardHonor
local GetQuestLogRewardSpell, GetQuestLogRewardTitle, GetQuestLogRewardInfo = GetQuestLogRewardSpell, GetQuestLogRewardTitle, GetQuestLogRewardInfo
local GetQuestLogChoiceInfo, GetQuestLogItemLink, GetQuestLogTitle = GetQuestLogChoiceInfo, GetQuestLogItemLink, GetQuestLogTitle
local GetNumQuestLogEntries, GetNumQuestLeaderBoards, GetNumRaidMembers = GetNumQuestLogEntries, GetNumQuestLeaderBoards, GetNumRaidMembers
local GetNumQuestLogRewards, GetNumQuestLogChoices, GetMaxDailyQuests = GetNumQuestLogRewards, GetNumQuestLogChoices, GetMaxDailyQuests
local GetNumPartyMembers, InCombatLockdown, IsInInstance, ExpandQuestHeader = GetNumPartyMembers, InCombatLockdown, IsInInstance, ExpandQuestHeader
local GetQuestLogSpecialItemInfo, GetItemCooldown, QuestLog_OpenToQuest = GetQuestLogSpecialItemInfo, GetItemCooldown, QuestLog_OpenToQuest
local CreateFrame, SetCVar, GetCVar, UIParent, ItemHasRange = CreateFrame, SetCVar, GetCVar, UIParent, ItemHasRange
local UnitName, UnitClass, UnitLevel, UnitFactionGroup, UnitAffectingCombat, UnitInRaid = UnitName, UnitClass, UnitLevel, UnitFactionGroup, UnitAffectingCombat, UnitInRaid
local GetMacroIndexByName, CreateMacro, EditMacro, PickupMacro = GetMacroIndexByName, CreateMacro, EditMacro, PickupMacro
local GetItemQualityColor, GetItemIcon, GetItemInfo, GetItemSpell, GetQuestLink = GetItemQualityColor, GetItemIcon, GetItemInfo, GetItemSpell, GetQuestLink
local GetContainerNumSlots, GetInventorySlotInfo, GetContainerItemLink, GetInventoryItemLink = GetContainerNumSlots, GetInventorySlotInfo, GetContainerItemLink, GetInventoryItemLink

-----------------
--- variables ---
-----------------
WATCHFRAME_MAXQUESTS = 100
WATCHFRAME_MAXACHIEVEMENTS = 100
MAX_WATCHABLE_QUESTS = 100
local _
local questLogNeedUpdate
local questLogUpdating
local MAX_PLAYER_LEVEL = MAX_PLAYER_LEVEL
local partyZone = tomQuest2.LC["PARTYQUESTSZONE"]
local dbVersion, lastCompatibleDB = 3, 1
local DUNGEON, HEROIC, RAID, ITEM_SPELL_TRIGGER_ONUSE, ITEM_STARTS_QUEST  = LFG_TYPE_DUNGEON, ITEM_HEROIC, LFG_TYPE_RAID, ITEM_SPELL_TRIGGER_ONUSE, ITEM_STARTS_QUEST
local COPPER_AMOUNT_SYMBOL, SILVER_AMOUNT_SYMBOL, GOLD_AMOUNT_SYMBOL = COPPER_AMOUNT_SYMBOL, SILVER_AMOUNT_SYMBOL, GOLD_AMOUNT_SYMBOL
local objectsPattern = "^"..QUEST_OBJECTS_FOUND:gsub("(%%%d?$?.)", "(.+)").."$"
local monstersPattern = "^"..QUEST_MONSTERS_KILLED:gsub("(%%%d?$?.)", "(.+)").."$"
local factionPattern = "^"..QUEST_FACTION_NEEDED:gsub("(%%%d?$?.)", "(.+)").."$"
local playersPattern = "^"..QUEST_PLAYERS_KILLED:gsub("(%%%d?$?.)", "(.+)").."$"
local dailyCounterPattern = "^"..DAILY_QUESTS_REMAINING:gsub("(%%%d?$?.)", "(.+)").."$"
local NO_DAILY_QUESTS_REMAINING = NO_DAILY_QUESTS_REMAINING
local itemUseLen = len(ITEM_SPELL_TRIGGER_ONUSE)
local scanTooltipTQ2 = CreateFrame( "GameTooltip", "scanTooltipTQ2", nil, "GameToolTipTemplate")
scanTooltipTQ2:SetOwner(WorldFrame, "ANCHOR_NONE")
local scanTooltipLines = {"scanTooltipTQ2TextLeft2", "scanTooltipTQ2TextLeft3", "scanTooltipTQ2TextLeft4", "scanTooltipTQ2TextLeft5"}
local backdrop = {
	bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
	insets = {top = -1, left = -1, bottom = -1, right = -1},
}
local items, itemsTimeStamp, inventorySlotId = {}, {}, {}
local tempTable1, tempTable2 = {}, {}

tomQuest2.playerName = UnitName("player")
tomQuest2.playerLevel = UnitLevel("player")
tomQuest2.localClass, tomQuest2.playerClass = UnitClass("player")
tomQuest2.maxDaily = GetMaxDailyQuests()
tomQuest2.numEntries = 0
tomQuest2.numPartyMembers = 0
tomQuest2.numRaidMembers = 0
tomQuest2.firstRun = true
tomQuest2.completedString = "|cff00ff00"..tomQuest2.LC["Finished"].."|r"
tomQuest2.failedString = "|cffff0000"..tomQuest2.LC["Failed"].."|r"
tomQuest2.numItemButtons = 0
tomQuest2.numNormalButtons = 0
tomQuest2.numCollapseButtons = 0
tomQuest2.numStatusBar = 0
tomQuest2.numUsableQuestItems = 0
tomQuest2.numItemsStartingQuest = 0
tomQuest2.numCompletedDailyQuests = 0

tomQuest2.party = {}
tomQuest2.quests, tomQuest2.questsObjectives, tomQuest2.questsTitleToUid, tomQuest2.moduleState = {}, {}, {}, {}
tomQuest2.sortedZones, tomQuest2.zones, tomQuest2.sortedQuestsByZone, tomQuest2.questsByZone, tomQuest2.sortedQuests = {}, {}, {}, {}, {}
tomQuest2.questsItems, tomQuest2.questsMobs = {}, {}
tomQuest2.achievementsItems, tomQuest2.achievementsMobs, tomQuest2.achievementName, tomQuest2.achievementIcon = {}, {}, {}, {}
tomQuest2.itemStartingQuest, tomQuest2.usableQuestItems = {}, {}
tomQuest2.collapsedHeader = {}
tomQuest2.classColors, tomQuest2.rarityColor = {}, {}
tomQuest2.normalButtonCache, tomQuest2.collapseButtonCache, tomQuest2.itemButtonCache, tomQuest2.statusBarCache = {}, {}, {}, {}

tomQuest2.reactions = {
	[FACTION_STANDING_LABEL1] = 1, [FACTION_STANDING_LABEL1_FEMALE] = 1,
	[FACTION_STANDING_LABEL2] = 2, [FACTION_STANDING_LABEL2_FEMALE] = 2,
	[FACTION_STANDING_LABEL3] = 3, [FACTION_STANDING_LABEL3_FEMALE] = 3,
	[FACTION_STANDING_LABEL4] = 4, [FACTION_STANDING_LABEL4_FEMALE] = 4,
	[FACTION_STANDING_LABEL5] = 5, [FACTION_STANDING_LABEL5_FEMALE] = 5,
	[FACTION_STANDING_LABEL6] = 6, [FACTION_STANDING_LABEL6_FEMALE] = 6,
	[FACTION_STANDING_LABEL7] = 7, [FACTION_STANDING_LABEL7_FEMALE] = 7,
	[FACTION_STANDING_LABEL8] = 8, [FACTION_STANDING_LABEL8_FEMALE] = 8,
}
tomQuest2.bagList  = {[0] = true, [1] = true, [2] = true, [3] = true, [4] = true}
tomQuest2.inventorySlot = {"HeadSlot", "NeckSlot", "ShoulderSlot", "BackSlot", "ChestSlot", "ShirtSlot", "TabardSlot", "WristSlot", "HandsSlot", "WaistSlot", "LegsSlot", "FeetSlot", "Finger0Slot", "Finger1Slot", "Trinket0Slot", "Trinket1Slot", "MainHandSlot", "SecondaryHandSlot", "RangedSlot", "AmmoSlot"}

for rarity = 0, 6 do
	local r, g, b = GetItemQualityColor(rarity)
	tomQuest2.rarityColor[rarity] = format("%02x%02x%02x", r*255, g*255, b*255)
end

local specialItems = {["32971"] = true}

----------------------------
--- Button & item Button ---
----------------------------
local function skinChanged(self, SkinID, Gloss, Backdrop, Group, Button, Colors)
	tomQuest2.db.profile.skin.skin = SkinID
	tomQuest2.db.profile.skin.gloss = Gloss
	tomQuest2.db.profile.skin.backdrop = Backdrop
	tomQuest2.db.profile.skin.Colors = Colors
end

function tomQuest2:getItemButton()
	local button = tremove(self.itemButtonCache)
	if button then
		button.iconTexture:SetVertexColor(1.0, 1.0, 1.0)
	else
		self.numItemButtons = self.numItemButtons + 1
		local buttonName = "tomQuest2ItemButton"..self.numItemButtons
		button = CreateFrame("Button", buttonName, UIParent, "WatchFrameItemButtonTemplate")
		button.iconTexture = _G[buttonName.."IconTexture"]
		button.coolDown = _G[buttonName.."Cooldown"]
		button.count = _G[buttonName.."Count"]
		button.height = button:GetHeight()
		button:SetNormalTexture("")
		button:SetPushedTexture("")
		button:SetHighlightTexture("")
		_G[buttonName.."HotKey"]:Hide()
		button.type = "item"
		if self.LBFGroup then
			self.LBFGroup:AddButton(button)
		end
		button:SetScript("OnEvent", nil)
		button:SetScript("OnUpdate", nil)
		button:SetScript("OnLoad", nil)
	end
	_G[button:GetName().."Count"]:Hide()
	button.duration = 0
	return button
end

function tomQuest2:getNormalButton()
	local button = tremove(self.normalButtonCache)
	if not button then
		self.numNormalButtons = self.numNormalButtons + 1
		local buttonName = "tomQuest2NormalButton"..self.numNormalButtons
		button = CreateFrame("Button", buttonName, UIParent, "ItemButtonTemplate")
		button.iconTexture = _G[buttonName.."IconTexture"]
		button.height = button:GetHeight()
		button:SetNormalTexture("")
		button:SetPushedTexture("")
		button:SetHighlightTexture("")
		button.type = "normal"
		button:RegisterForClicks("AnyDown")
		if self.LBFGroup then
			self.LBFGroup:AddButton(button)
		end
	end
	return button
end

function tomQuest2:getCollapseButton()
	local button = tremove(self.collapseButtonCache)
	if not button then
		self.numCollapseButtons = self.numCollapseButtons + 1
		local buttonName = "tomQuest2CollapseButton"..self.numCollapseButtons
		button = CreateFrame("Button", buttonName, UIParent, "ItemButtonTemplate")
		button.iconTexture = _G[buttonName.."IconTexture"]
		button.height = button:GetHeight()
		button:SetNormalTexture("")
		button:SetPushedTexture("")
		button:SetHighlightTexture("")
		button.type = "collapse"
	end
	return button
end

function tomQuest2:getStatusBar()
	local statusBar = tremove(self.statusBarCache)
	if not statusBar then
		self.numStatusBar = self.numStatusBar + 1
		local statusBarName = "tomQuest2StatusBar"..self.numStatusBar
		statusBar = CreateFrame("StatusBar", statusBarName, UIParent)
		statusBar.status = statusBar:CreateFontString(statusBarName.."Status", "OVERLAY")
		statusBar.status:SetJustifyH("CENTER")
		statusBar.status:SetPoint("CENTER")
		statusBar.bg = statusBar:CreateTexture(nil, "BORDER")
		statusBar.bg:SetAllPoints(statusBar)
		statusBar:SetBackdrop(backdrop)
		statusBar:SetBackdropColor(0, 0, 0)
	end
	return statusBar
end

function tomQuest2:recycleButton(button)
	if not button then return end
	button:SetParent(UIParent)
	button:ClearAllPoints()
	button:Hide()
	if button.type == "collapse" then
		button:SetScript("OnClick", nil)
		button:RegisterForClicks()
		button.category = nil
		self.collapseButtonCache[#(self.collapseButtonCache)+1] = button
	elseif button.type == "item" then
		button:SetScript("OnUpdate", nil)
		button:SetScript("OnEvent", nil)
		button:UnregisterEvent("BAG_UPDATE_COOLDOWN")
		button:UnregisterEvent("PLAYER_TARGET_CHANGED")
		button.link = nil
		self.itemButtonCache[#(self.itemButtonCache)+1] = button
	elseif button.type == "normal" then
		button:SetScript("OnClick", nil)
		button.link = nil
		self.normalButtonCache[#(self.normalButtonCache)+1] = button
	end
end

function tomQuest2:recycleStatusBar(statusBar)
	if not statusBar then return end
	statusBar:SetParent(UIParent)
	statusBar:ClearAllPoints()
	statusBar:Hide()
	self.statusBarCache[#(self.statusBarCache)+1] = statusBar
end

---------------------
--- Zones Sorting ---
---------------------
local zSort = {
	nameD = function(a, b)
		return a > b
	end,
	nameA = function(a, b)
		return a < b
	end,
	levelD = function(a, b)
		local aMin, aMax = tomQuest2.zones[a].sMinLevel, tomQuest2.zones[a].sMaxLevel
		local bMin, bMax = tomQuest2.zones[b].sMinLevel, tomQuest2.zones[b].sMaxLevel
		if aMax == bMax then
			if aMin == bMin then
				return a > b
			else
				return aMin > bMin
			end
		else
			return aMax > bMax
		end
	end,
	levelA = function(a, b)
		local aMin, aMax = tomQuest2.zones[a].sMinLevel, tomQuest2.zones[a].sMaxLevel
		local bMin, bMax = tomQuest2.zones[b].sMinLevel, tomQuest2.zones[b].sMaxLevel
		if aMax == bMax then
			if aMin == bMin then
				return a < b
			else
				return aMin < bMin
			end
		else
			return aMax < bMax
		end
	end
}

local function zonesSort()
	local tIndex = 0
	for zone in pairs(tomQuest2.zones) do
		tIndex = tIndex + 1
		tomQuest2.sortedZones[tIndex] = zone
	end
	for i = tIndex + 1, #(tomQuest2.sortedZones) do
		tomQuest2.sortedZones[i] = nil
	end
	sort(tomQuest2.sortedZones, zSort[tomQuest2.db.profile.quests.zoneSorting])
end
tomQuest2.zonesSort = zonesSort

----------------------
--- Quests Sorting ---
----------------------
local qSort = {
	weightedA = function(a, b)
		local aWL, bWL = tomQuest2.quests[a].weightedLevel or 0, tomQuest2.quests[b].weightedLevel or 0
		if aWL == bWL then
			return tomQuest2.quests[a].title < tomQuest2.quests[b].title
		else
			return aWL < bWL
		end
	end,
	weightedD = function(a, b)
		local aWL, bWL = tomQuest2.quests[a].weightedLevel or 0, tomQuest2.quests[b].weightedLevel or 0
		if aWL == bWL then
			return tomQuest2.quests[a].title > tomQuest2.quests[b].title
		else
			return aWL > bWL
		end
	end,
	levelA = function(a, b)
		local aL, bL = tomQuest2.quests[a].level, tomQuest2.quests[b].level
		if aL == bL then
			return tomQuest2.quests[a].title < tomQuest2.quests[b].title
		else
			return aL < bL
		end
	end,
	levelD = function(a, b)
		local aL, bL = tomQuest2.quests[a].level, tomQuest2.quests[b].level
		if aL == bL then
			return tomQuest2.quests[a].title > tomQuest2.quests[b].title
		else
			return aL > bL
		end
	end,
	nameA = function(a, b)
		return tomQuest2.quests[a].title > tomQuest2.quests[b].title
	end,
	nameD = function(a, b)
		return tomQuest2.quests[a].title < tomQuest2.quests[b].title
	end,
}

local function questsSort()
	local tIndex1 = 0
	for zone in pairs(tomQuest2.zones) do
		local tIndex2 = 0
		for uid in pairs(tomQuest2.questsByZone[zone]) do
			tIndex1 = tIndex1 + 1
			tIndex2 = tIndex2 + 1
			tomQuest2.sortedQuestsByZone[zone][tIndex2] = uid
			tomQuest2.sortedQuests[tIndex1] = uid
		end
		for i = tIndex2 + 1, #(tomQuest2.sortedQuestsByZone[zone]) do
			tomQuest2.sortedQuestsByZone[zone][i] = nil
		end
		sort(tomQuest2.sortedQuestsByZone[zone], qSort[tomQuest2.db.profile.quests.questsSorting])
	end
	for i = tIndex1 + 1, #(tomQuest2.sortedQuests) do
		tomQuest2.sortedQuests[i] = nil
	end
	sort(tomQuest2.sortedQuests, qSort[tomQuest2.db.profile.quests.questsSorting])
end
tomQuest2.questsSort = questsSort

-----------------------
--- Tools functions ---
-----------------------
local levelTag = {
	elite = function(uid, level, group)
		tomQuest2.quests[uid].weightedLevel = level + tomQuest2.db.profile.quests.eliteAddLevel
	end,
	group = function(uid, level, group)
		tomQuest2.quests[uid].weightedLevel = level + (tomQuest2.db.profile.quests.groupAddLevel * (group - tomQuest2.numPartyMembers))
	end,
	heroic = function(uid, level, group)
		tomQuest2.quests[uid].weightedLevel = level + (tomQuest2.db.profile.quests.heroicAddLevel * (group - tomQuest2.numPartyMembers))
	end,
	dungeon = function(uid, level, group)
		tomQuest2.quests[uid].weightedLevel = level + (tomQuest2.db.profile.quests.dungeonAddLevel * (group - tomQuest2.numPartyMembers))
	end,
	raid = function(uid, level, group)
		tomQuest2.quests[uid].weightedLevel = level + (tomQuest2.db.profile.quests.raidAddLevel * ((group or 25) - (tomQuest2.numRaidMembers > 0 and tomQuest2.numRaidMembers or tomQuest2.numPartyMembers)))
	end,
	escort = function(uid, level, group)
		tomQuest2.quests[uid].weightedLevel = level
	end,
	pvp = function(uid, level, group)
		tomQuest2.quests[uid].weightedLevel = level
	end,
	daily = function(uid, level, group)
		tomQuest2.quests[uid].weightedLevel = level
	end,
	notag = function(uid, level, group)
		tomQuest2.quests[uid].weightedLevel = level
	end,
}

local function getDifficultyColor(levelDiff)
	if levelDiff >= 5 then
		return QuestDifficultyColors["impossible"]
	elseif levelDiff >= 3 then
		return QuestDifficultyColors["verydifficult"]
	elseif levelDiff >= -2 then
		return QuestDifficultyColors["difficult"]
	elseif -levelDiff <= GetQuestGreenRange() then
		return QuestDifficultyColors["standard"]
	else
		return QuestDifficultyColors["trivial"]
	end
end

local function normalizeColorComponent(component)
	if component > 1 then return 1 elseif component < 0 then return 0 else return component end
end

local function getColorFromCompletionHEX(percent)
	if percent <= 0 then
		return format("%02x%02x%02x", 255*tomQuest2.db.profile.quests.rj0, 255*tomQuest2.db.profile.quests.gj0, 255*tomQuest2.db.profile.quests.bj0)
	elseif percent >= 1 then
		return format("%02x%02x%02x", 255*tomQuest2.db.profile.quests.rj3, 255*tomQuest2.db.profile.quests.gj3, 255*tomQuest2.db.profile.quests.bj3)
	elseif percent <= 0.5 then
		return format("%02x%02x%02x", 255*normalizeColorComponent(tomQuest2.db.profile.quests.ri1*percent + tomQuest2.db.profile.quests.rj1), 255*normalizeColorComponent(tomQuest2.db.profile.quests.gi1*percent + tomQuest2.db.profile.quests.gj1), 255*normalizeColorComponent(tomQuest2.db.profile.quests.bi1*percent + tomQuest2.db.profile.quests.bj1))
	else
		return format("%02x%02x%02x", 255*normalizeColorComponent(tomQuest2.db.profile.quests.ri2*percent + tomQuest2.db.profile.quests.rj2), 255*normalizeColorComponent(tomQuest2.db.profile.quests.gi2*percent + tomQuest2.db.profile.quests.gj2), 255*normalizeColorComponent(tomQuest2.db.profile.quests.bi2*percent + tomQuest2.db.profile.quests.bj2))
	end
end

local function computeQuestStatus(self, uid)
	local playerStatus
	local tIndex = 0
	self.quests[uid].playerComplete = 0
	self.quests[uid].partyComplete = 1
	for partyName, completed in pairs(self.quests[uid].complete) do
		if completed == 0 then
			self.quests[uid].partyComplete = 0
		elseif completed == 1 then
			if partyName == self.playerName then
				playerStatus = self.completedString
				self.quests[uid].playerComplete = 1
			else
				tIndex = tIndex + 1
				tempTable1[tIndex] = "|cff"..self.party[partyName].color..self.party[partyName].subName.."|r: "..self.completedString
			end
		elseif completed == -1 then
			self.quests[uid].partyComplete = 0
			if partyName == self.playerName then
				playerStatus = self.failedString
			else
				tIndex = tIndex + 1
				tempTable1[tIndex] = "|cff"..self.party[partyName].color..self.party[partyName].subName.."|r: "..self.failedString
			end
		end
	end
	if playerStatus then
		tIndex = tIndex + 1
		tempTable1[tIndex] = playerStatus
	end
	self.quests[uid].pqStatus = tconcat(tempTable1, ", ", 1, tIndex)
end
tomQuest2.computeQuestStatus = computeQuestStatus

local function computeQuestObjectiveStatus(self, uid, objective)
	local tIndex = 0
	local totalGot = 0
	local nNeed = self.questsObjectives[uid][objective].nNeed
	local totalNeed = nNeed * self.quests[uid].playersOnQuest
	local playerStatus, playerStatusNC
	self.questsObjectives[uid][objective].playerComplete = 0
	self.questsObjectives[uid][objective].partyComplete = 1
	for partyName, qoData in pairs(self.questsObjectives[uid][objective].got) do
		local nGot = self.questsObjectives[uid][objective].nGot[partyName]
		totalGot = totalGot + nGot
		if nGot == nNeed then
			if partyName == self.playerName then
				self.questsObjectives[uid][objective].playerComplete = 1
				playerStatus = "|cff"..getColorFromCompletionHEX(1)..tomQuest2.LC["d"].."|r"
				playerStatusNC = tomQuest2.LC["d"]
			else
				tIndex = tIndex + 1
				tempTable1[tIndex] = "|cff"..self.party[partyName].color..self.party[partyName].subName.."|r : |cff"..getColorFromCompletionHEX(1)..tomQuest2.LC["d"].."|r"
				tempTable2[tIndex] = "|cff"..self.party[partyName].color..self.party[partyName].subName.."|r: "..tomQuest2.LC["d"]
			end
		else
			self.questsObjectives[uid][objective].partyComplete = 0
			if partyName == self.playerName then
				playerStatus = "|cff"..getColorFromCompletionHEX(nGot/nNeed)..qoData.."|r"
				playerStatusNC = qoData
			else
				tIndex = tIndex + 1
				tempTable1[tIndex] = "|cff"..self.party[partyName].color..self.party[partyName].subName.."|r : |cff"..getColorFromCompletionHEX(nGot/nNeed)..qoData.."|r"
				tempTable2[tIndex] = "|cff"..self.party[partyName].color..self.party[partyName].subName.."|r: "..qoData
			end
		end
	end
	if playerStatus then
		tIndex = tIndex + 1
		tempTable1[tIndex] = playerStatus
		tempTable2[tIndex] = playerStatusNC
	end
	self.questsObjectives[uid][objective].qoColor = getColorFromCompletionHEX(totalGot/totalNeed)
	self.questsObjectives[uid][objective].qoStatus = tconcat(tempTable1, " ,", 1, tIndex).."|cff"..self.questsObjectives[uid][objective].qoColor.."/"..self.questsObjectives[uid][objective].need.."|r"
	self.questsObjectives[uid][objective].qoStatusNC = tconcat(tempTable2, " ,", 1, tIndex).."/"..self.questsObjectives[uid][objective].need
end
tomQuest2.computeQuestObjectiveStatus = computeQuestObjectiveStatus

local function computeQuestLevel()
	for uid, questData in pairs(tomQuest2.quests) do
		levelTag[questData.shortTag](uid, questData.level, questData.group)
	end
	questsSort()
	tomQuest2.cbh:Fire("updateQuestsTracker")
end
tomQuest2.computeQuestLevel = computeQuestLevel

local function computeQuestTag()
	for uid, questData in pairs(tomQuest2.quests) do
		local tagLevel = 0
		if tomQuest2.db.profile.quests.level == "questLevel" and questData.level > 0 then
			tagLevel = questData.level
		elseif tomQuest2.db.profile.quests.level == "weightedQuestLevel" and questData.weightedLevel > 0 then
			tagLevel = questData.weightedLevel
		end
		if tagLevel > 0 or questData.shortTag ~= "notag" or questData.group > 0 or questData.daily == 1 then
			tomQuest2.quests[uid].tag = "["..(tagLevel > 0 and tagLevel or "")..tomQuest2.db.profile.quests[questData.shortTag]..(questData.group > 0 and questData.group or "")..(questData.daily == 1 and (questData.shortTag ~= "daily" and tomQuest2.db.profile.quests["daily"] or "") or "").."]"
		else
			tomQuest2.quests[uid].tag = ""
		end
	end
	tomQuest2.cbh:Fire("updateQuestsTracker")
end
tomQuest2.computeQuestTag = computeQuestTag

-------------------
--- Class Color ---
-------------------
for class, color in pairs(CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS) do
	tomQuest2.classColors[class] = format("%02x%02x%02x", color.r*255, color.g*255, color.b*255)
end
local playerColor = tomQuest2.classColors[tomQuest2.playerClass]

local function updateClassColors()
	local updateTooltip
	for class, color in pairs(CUSTOM_CLASS_COLORS) do
		tomQuest2.classColors[class] = format("%02x%02x%02x", color.r*255, color.g*255, color.b*255)
	end
	if tomQuest2.classColors[tomQuest2.playerClass] ~= playerColor then
		playerColor = tomQuest2.classColors[tomQuest2.playerClass]
		if tomQuest2.zones[tomQuest2.localClass] then
			tomQuest2.zones[tomQuest2.localClass].color = playerColor
			updateTooltip = true
		end
	end
	local colorUpdated
	local tIndex = 0
	for partyName, pData in pairs(tomQuest2.party) do
		if pData.color ~= tomQuest2.classColors[pData.class] then
			tIndex = tIndex + 1
			tomQuest2.party[partyName].color = tomQuest2.classColors[pData.class]
			tempTable1[tIndex] = partyName
		end
	end
	for i = tIndex + 1, #(tempTable1) do
		tempTable1[i] = nil
	end
	if #tempTable1 > 0 then
		for uid, qData in pairs(tomQuest2.quests) do
			local update
			for _, partyName in pairs(tempTable1) do
				if qData.complete[partyName] then
					update = true
					break
				end
			end
			if update then
				computeQuestStatus(tomQuest2, uid)
				if qData.numObjectives > 0 then
					for objective in pairs(tomQuest2.questsObjectives[uid]) do
						computeQuestObjectiveStatus(tomQuest2, uid, objective)
					end
				end
				updateTooltip = true
			end
		end
	end
	if updateTooltip then
		tomQuest2.cbh:Fire("updateQuestsTooltip")
	end
end

-----------------------
--- Default profile ---
-----------------------
local defaults = {
	profile = {
		skin = {
			skin = "DreamLayout",
			gloss = 0,
			backdrop = false,
			Colors = {},
		},
		modules = {
			dailyTooltip = true,
			notifications = true,
			informations = true,
			questsTooltip = true,
			questsTracker = true,
			soundNotifications = true,
			syncParty = true,
			questsGivers = true,
			tagQuestLog = true,
			tooltips = true,
			announce = false,
			achievementTracker = true,
			questsInfo = true,
		},
		raidModules = {
			enabled = true,
			dailyTooltip = "inRaidInstance",
			notifications = "inRaidInstance",
			informations = "enabled",
			questsTooltip = "enabled",
			questsTracker = "inRaidInstance",
			soundNotifications = "enabled",
			syncParty = "inRaidInstance",
			questsGivers = "enabled",
			tagQuestLog = "enabled",
			tooltips = "inRaidInstance",
			announce = "inRaidInstance",
			achievementTracker = "enabled",
			questsInfo = "enabled",
		},
		quests = {
			colorizeMoney = true, moneySeparator = "symbol", partyHeader = true,
			zoneSorting = "levelA", zoneWithoutLvlPos = 0, questsSorting = "weightedA",
			hideDefaultBlizTracker = true,
			maxLevelDiff = 3, eliteAddLevel = 3, groupAddLevel = 1, dungeonAddLevel = 2, heroicAddLevel = 3, raidAddLevel = 1,
			level = "questLevel", elite = "+", group = "g", pvp = "p", raid = "r", dungeon = "d", heroic = "d+", daily = "\226\128\162", escort = "e", notag = "",
			completedColor = "00ff00", failedColor = "ff0000",
			customColorMode = true,
			rj0 = 1, gj0 = 0, bj0 = 0,
			ri1 = 0, rj1 = 1, gi1 = 2, gj1 = 0, bi1 = 0, bj1 = 0,
			ri2 = -2, rj2 = 2, gi2 = 0, gj2 = 1, bi2 = 0, bj2 = 0,
			rj3 = 0, gj3 = 1, bj3 = 0,
		},
	},
}

----------------------
--- Initialization ---
----------------------
function tomQuest2:Print(text)
	if text then
		DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99tomQuest2|r: "..text)
	end
end

tomQuest2:SetDefaultModuleState(false)

function tomQuest2:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("tomQuest2DB", defaults, "Default")
	self.db.RegisterCallback(self, "OnProfileChanged", "Refresh")
	self.db.RegisterCallback(self, "OnProfileCopied", "Refresh")
	self.db.RegisterCallback(self, "OnProfileReset", "Refresh")
	self.autoQuestWatch = GetCVar("autoQuestWatch")
	self.autoQuestProgress = GetCVar("autoQuestProgress")
	self.db.profile.dailyList = self.db.profile.dailyList or {}
	self.completedString = "|cff"..self.db.profile.quests.completedColor..self.LC["Finished"].."|r"
	self.failedString = "|cff"..self.db.profile.quests.failedColor..self.LC["Failed"].."|r"
	if self.db.profile.modules["questsTracker"] then
		SetCVar("autoQuestWatch", 0)
		SetCVar("autoQuestProgress", 0)
	end
	if self.db.profile.version and self.db.profile.version < lastCompatibleDB then
		self.db:ResetDB()
		self:Refresh()
	end
	self.db.profile.version = dbVersion
	for _, v in pairs(self.inventorySlot) do
		local slotId = GetInventorySlotInfo(v)
		inventorySlotId[slotId] = true
	end
	self:RegisterEvent("CHAT_MSG_SYSTEM")
	self:RegisterEvent("QUEST_LOG_UPDATE")
	if self.playerLevel ~= MAX_PLAYER_LEVEL then
		self:RegisterEvent("PLAYER_LEVEL_UP")
	end
	self:RegisterEvent("PARTY_MEMBERS_CHANGED")
	self:RegisterEvent("RAID_ROSTER_UPDATE", "checkRaid")
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "checkRaid")
end

function tomQuest2:OnEnable()
	ExpandQuestHeader(0)
	self.numCompletedDailyQuests = GetDailyQuestsCompleted() or 0
	if self.numCompletedDailyQuests == 0 and self.db.profile.dailyList[self.playerName] and self.db.profile.dailyList[self.playerName].dailies then
		for quest in pairs(self.db.profile.dailyList[self.playerName].dailies) do
			self.db.profile.dailyList[self.playerName].dailies[quest] = nil
		end
	end
	if CUSTOM_CLASS_COLORS then
		CUSTOM_CLASS_COLORS:RegisterCallback(updateClassColors)
	end
	self:SecureHook("AbandonQuest")
	if self.db.profile.quests.hideDefaultBlizTracker then
		self:SecureHook("WatchFrame_Update")
		WatchFrame:Hide()
	end
	if self.LBF then
		self.LBFGroup = self.LBF:Group("tomQuest2", "Items")
		self.LBFGroup.SkinID = self.db.profile.skin.skin or "DreamLayout"
		self.LBFGroup.Backdrop = self.db.profile.skin.backdrop
		self.LBFGroup.Gloss = self.db.profile.skin.gloss
		self.LBFGroup.Colors = self.db.profile.skin.Colors
		self.LBF:RegisterSkinCallback("tomQuest2", skinChanged, self)
	end
end

function tomQuest2:OnDisable()
	SetCVar("autoQuestWatch", self.autoQuestWatch)
	SetCVar("autoQuestProgress", self.autoQuestProgress)
end

function tomQuest2:Refresh()
	self.db.profile.version = dbVersion
	for k, v in self:IterateModules() do
		if self.moduleState[k] and not v:IsEnabled() then
			self:EnableModule(k)
			self.moduleState[k] = true
		elseif not self.moduleState[k] and v:IsEnabled() then
			self:DisableModule(k)
			self.moduleState[k] = nil
		end
		if v.Refresh and type(v.Refresh) == "function" then
			v:Refresh()
		end
	end
	computeQuestTag()
	for uid, qoData in pairs (self.questsObjectives) do
		for objective in pairs (qoData) do
			computeQuestObjectiveStatus(self, uid, objective)
		end
	end
	if self.db.profile.quests.hideDefaultBlizTracker then
		self:SecureHook("WatchFrame_Update")
		WatchFrame:Hide()
	else
		self:Unhook("WatchFrame_Update")
		WatchFrame:Show()
	end
	if self.LBF then
		self.LBFGroup = self.LBF:Group("tomQuest2", "Items")
		self.LBFGroup.SkinID = self.db.profile.skin.skin or "DreamLayout"
		self.LBFGroup.Backdrop = self.db.profile.skin.backdrop
		self.LBFGroup.Gloss = self.db.profile.skin.gloss
		self.LBFGroup.Colors = self.db.profile.skin.Colors
		self.LBF:RegisterSkinCallback("tomQuest2", skinChanged)
	end
	self.cbh:Fire("updateQuestsTracker")
	self.cbh:Fire("questLogUpdated", true, true)
end

function tomQuest2:getModuleEnabled(module)
	return self.db.profile.modules[module]
end

function tomQuest2:setModuleEnabled(module, value)
	local old = self.db.profile.modules[module]
	self.db.profile.modules[module] = value
	if old ~= value then
		if value then
			self:EnableModule(module)
			self.moduleState[module] = true
			self:Print(format(self.LC["%s module is now Enabled"], module))
			if module == "questsTracker" then
				SetCVar("autoQuestWatch", 0)
				SetCVar("autoQuestProgress", 0)
			end
		else
			self:DisableModule(module)
			self.moduleState[module] = nil
			self:Print(format(self.LC["%s module is now Disabled"], module))
		end
	end
end

function tomQuest2:toggleModule(module)
	if self.moduleState[module] then
		self:setModuleEnabled(module, false)
	else
		self:setModuleEnabled(module, true)
	end
end

function tomQuest2:checkRaid(event, forced)
	local numRaidMembersOld = self.numRaidMembers
	self.numRaidMembers = GetNumRaidMembers()
	if self.numRaidMembers ~= numRaidMembersOld then
		computeQuestLevel()
	end
	if not self.db.profile.raidModules.enabled then return end
	local inRaid = UnitInRaid("player")
	local _, instanceType = IsInInstance()
	local inRaidInstance = instanceType == "raid" and true or nil
	if (inRaid and (not self.oldInRaid or forced)) or (not inRaid and self.oldInRaid) then
		for k in self:IterateModules() do
			if self.db.profile.raidModules[k] == "inRaid" then
				if inRaid and self.moduleState[k] then
					self:DisableModule(k)
					self.moduleState[k] = nil
					self:Print(format(self.LC["%s module is now Disabled"], k))
				elseif not inRaid and not self.moduleState[k] and self.db.profile.modules[k] then
					self:EnableModule(k)
					self.moduleState[k] = true
					self:Print(format(self.LC["%s module is now Enabled"], k))
				end
			elseif self.db.profile.raidModules[k] == "hiddenInRaid" and self.moduleState[k] then
				if k == "questsTracker" then
					tQ2toggleQuestTracker(inRaid and 0 or 1)
				elseif k == "achievementTracker" then
					tQ2toggleAchievementTracker(inRaid and 0 or 1)
				end
			end
		end
	end
	if (inRaidInstance and (not self.oldInRaidInstance or forced)) or (not inRaidInstance and self.oldInRaidInstance) then
		for k in self:IterateModules() do
			if self.db.profile.raidModules[k] == "inRaidInstance" then
				if inRaidInstance and self.moduleState[k] then
					self:DisableModule(k)
					self.moduleState[k] = nil
					self:Print(format(self.LC["%s module is now Disabled"], k))
				elseif not inRaidInstance and not self.moduleState[k] and self.db.profile.modules[k] then
					self:EnableModule(k)
					self.moduleState[k] = true
					self:Print(format(self.LC["%s module is now Enabled"], k))
				end
			elseif self.db.profile.raidModules[k] == "hiddenInRaidInstance" and self.moduleState[k] then
				if k == "questsTracker" then
					tQ2toggleQuestTracker(inRaidInstance and 0 or 1)
				elseif k == "achievementTracker" then
					tQ2toggleAchievementTracker(inRaidInstance and 0 or 1)
				end
			end
		end
	end
	self.oldInRaid = inRaid
	self.oldInRaidInstance = inRaidInstance
end

function tomQuest2:PARTY_MEMBERS_CHANGED()
	local oldNumPartyMembers = self.numPartyMembers
	self.numPartyMembers = GetNumPartyMembers() or 0
	if self.numPartyMembers ~= oldNumPartyMembers then
		self.cbh:Fire("partyChanged")
		if oldNumPartyMembers == 0 then
			self.cbh:Fire("playerJoinedParty")
		elseif self.numPartyMembers == 0 then
			self.cbh:Fire("playerLeftParty")
		end
		computeQuestLevel()
	end
end

------------------------------------
--- Bliz Quest Tracker show hide ---
------------------------------------
function tomQuest2:WatchFrame_Update()
	WatchFrame:Hide()
end

function tomQuest2:hideShowDefaultBlizTracker()
	if self.quests.hideDefaultBlizTracker then
		WatchFrame:Hide()
		self:SecureHook("WatchFrame_Update")
	else
		WatchFrame:Show()
		self:Unhook("WatchFrame_Update")
	end
end

-------------------------
--- Hook AbandonQuest ---
-------------------------
function tomQuest2:AbandonQuest()
	self.abandoning = true
end

-----------------------
--- Money formating ---
-----------------------
function tomQuest2:formatMoney(money)
	local tIndex = 0
	local gold = floor(money / 10000)
	local silver = mod(floor(money / 100), 100)
	local copper = mod(floor(money), 100)
	if self.db.profile.quests.moneySeparator == "dot" then
		if self.db.profile.quests.colorizeMoney then
			if gold > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = "|cffffd700"..gold.."|r"
			end
			if silver > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = "|cffc7c7cf"..silver.."|r"
			end
			if copper > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = "|cffeda55f"..copper.."|r"
			end
		else
			if gold > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = gold
			end
			if silver > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = silver
			end
			if copper > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = copper
			end
		end
		return tconcat(tempTable1, ".", 1, tIndex)
	elseif self.db.profile.quests.moneySeparator == "symbol" then
		if self.db.profile.quests.colorizeMoney then
			if gold > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = "|cffffd700"..gold..GOLD_AMOUNT_SYMBOL.."|r"
			end
			if silver > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = "|cffc7c7cf"..silver..SILVER_AMOUNT_SYMBOL.."|r"
			end
			if copper > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = "|cffeda55f"..copper..COPPER_AMOUNT_SYMBOL.."|r"
			end
		else
			if gold > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = gold..GOLD_AMOUNT_SYMBOL
			end
			if silver > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = silver..SILVER_AMOUNT_SYMBOL
			end
			if copper > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = copper..COPPER_AMOUNT_SYMBOL
			end
		end
		return tconcat(tempTable1, "", 1, tIndex)
	elseif self.db.profile.quests.moneySeparator == "texture" then
		if self.db.profile.quests.colorizeMoney then
			if gold > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = "|cffffd700"..gold.."|r|TInterface\\MoneyFrame\\UI-GoldIcon:20|t"
			end
			if silver > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = "|cffc7c7cf"..silver.."|r|TInterface\\MoneyFrame\\UI-SilverIcon:20|t"
			end
			if copper > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = "|cffeda55f"..copper.."|r|TInterface\\MoneyFrame\\UI-CopperIcon:20|t"
			end
		else
			if gold > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = gold.."|TInterface\\MoneyFrame\\UI-GoldIcon:20|t"
			end
			if silver > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = silver.."|TInterface\\MoneyFrame\\UI-SilverIcon:20|t"
			end
			if copper > 0 then
				tIndex = tIndex + 1
				tempTable1[tIndex] = copper.."|TInterface\\MoneyFrame\\UI-CopperIcon:20|t"
			end
		end
		return tconcat(tempTable1, "", 1, tIndex)
	end
end

------------------------
--- Quests Functions ---
------------------------
local function addZone(zone)
	tomQuest2.zones[zone] = {}
	tomQuest2.zones[zone].numQuests = 0
	tomQuest2.questsByZone[zone] = {}
	tomQuest2.sortedQuestsByZone[zone] = {}
	if zone == partyZone then
		tomQuest2.zones[zone].minLevel = ""
		tomQuest2.zones[zone].maxLevel = ""
		tomQuest2.zones[zone].sMinLevel = tomQuest2.db.profile.quests.zoneWithoutLvlPos
		tomQuest2.zones[zone].sMaxLevel = tomQuest2.db.profile.quests.zoneWithoutLvlPos
		tomQuest2.zones[zone].level = ""
		tomQuest2.zones[zone].color = "ffffff"
		tomQuest2.zones[zone].zone = true
	elseif zone == tomQuest2.localClass then
		tomQuest2.zones[zone].minLevel = ""
		tomQuest2.zones[zone].maxLevel = ""
		tomQuest2.zones[zone].sMinLevel = tomQuest2.db.profile.quests.zoneWithoutLvlPos
		tomQuest2.zones[zone].sMaxLevel = tomQuest2.db.profile.quests.zoneWithoutLvlPos
		tomQuest2.zones[zone].level = ""
		tomQuest2.zones[zone].color = playerColor
	else
		tomQuest2.zones[zone].minLevel, tomQuest2.zones[zone].maxLevel = LibTourist:GetLevel(zone)
		tomQuest2.zones[zone].sMinLevel, tomQuest2.zones[zone].sMaxLevel = tomQuest2.zones[zone].minLevel, tomQuest2.zones[zone].maxLevel
		if tomQuest2.zones[zone].maxLevel == 0 then
			tomQuest2.zones[zone].level = ""
			tomQuest2.zones[zone].color = "ffffff"
		else
			tomQuest2.zones[zone].level = "("..tomQuest2.zones[zone].minLevel.."-"..tomQuest2.zones[zone].maxLevel..")"
			local r, g, b = LibTourist:GetLevelColor(zone)
			tomQuest2.zones[zone].color = format("%02x%02x%02x", r*255, g*255, b*255)
			tomQuest2.zones[zone].zone = true
		end
	end
end
tomQuest2.addZone = addZone

local function addQuest(uid, title, level, qtag, group, daily, numObjectives, zone)
	tomQuest2.quests[uid] = {}
	tomQuest2.quests[uid].numObjectives = numObjectives
	if numObjectives > 0 then
		tomQuest2.questsObjectives[uid] = {}
	end
	tomQuest2.quests[uid].playersOnQuest = 0
	tomQuest2.quests[uid].playerComplete = 0
	tomQuest2.quests[uid].partyComplete = 0
	tomQuest2.quests[uid].title = title
	tomQuest2.quests[uid].level = level
	tomQuest2.quests[uid].zone = zone
	tomQuest2.quests[uid].complete = {}
	local qc = getDifficultyColor(level - tomQuest2.playerLevel)
	tomQuest2.quests[uid].color = format("%02x%02x%02x", qc.r*255, qc.g*255, qc.b*255)
	tomQuest2.quests[uid].shortTag = qtag
	tomQuest2.quests[uid].group = group
	tomQuest2.quests[uid].daily = daily
	levelTag[qtag](uid, level, group)
	local tagLevel = 0
	if tomQuest2.db.profile.quests.level == "questLevel" and level > 0 then
		tagLevel = level
	elseif tomQuest2.db.profile.quests.level == "weightedQuestLevel" and tomQuest2.quests[uid].weightedLevel > 0 then
		tagLevel = tomQuest2.quests[uid].weightedLevel
	end
	if tagLevel > 0 or qtag ~= "notag" or group > 0 or daily == 1 then
		tomQuest2.quests[uid].tag = "["..(tagLevel > 0 and tagLevel or "")..tomQuest2.db.profile.quests[qtag]..(group > 0 and group or "")..(daily == 1 and (qtag ~= "daily" and tomQuest2.db.profile.quests["daily"] or "") or "").."]"
	else
		tomQuest2.quests[uid].tag = ""
	end
end
tomQuest2.addQuest = addQuest

local function addQuestObjective(uid, objective, desc, qType, need, nNeed)
	tomQuest2.questsObjectives[uid][objective] = {}
	tomQuest2.questsObjectives[uid][objective].desc = desc
	tomQuest2.questsObjectives[uid][objective].qType = qType
	tomQuest2.questsObjectives[uid][objective].nNeed = nNeed
	tomQuest2.questsObjectives[uid][objective].need = need
	tomQuest2.questsObjectives[uid][objective].got = {}
	tomQuest2.questsObjectives[uid][objective].nGot = {}
	if qType == "object" then
		if not tomQuest2.questsItems[desc] then
			tomQuest2.questsItems[desc] = {}
			tomQuest2.questsItems[desc].numQuests = 0
			tomQuest2.questsItems[desc].quests = {}
		end
		if not tomQuest2.questsItems[desc].quests[uid] then
			tomQuest2.questsItems[desc].numQuests = tomQuest2.questsItems[desc].numQuests + 1
			tomQuest2.questsItems[desc].quests[uid] = objective
		end
	elseif qType == "monster" then
		if not tomQuest2.questsMobs[desc] then
			tomQuest2.questsMobs[desc] = {}
			tomQuest2.questsMobs[desc].numQuests = 0
			tomQuest2.questsMobs[desc].quests = {}
		end
		if not tomQuest2.questsMobs[desc].quests[uid] then
			tomQuest2.questsMobs[desc].numQuests = tomQuest2.questsMobs[desc].numQuests + 1
			tomQuest2.questsMobs[desc].quests[uid] = objective
		end
	end
end
tomQuest2.addQuestObjective = addQuestObjective

local function removeQuestObjective(uid, objective)
	local qType = tomQuest2.questsObjectives[uid][objective].qType
	local desc = tomQuest2.questsObjectives[uid][objective].desc
	if qType == "object" then
		if tomQuest2.questsItems[desc] then
			tomQuest2.questsItems[desc].quests[uid] = nil
			tomQuest2.questsItems[desc].numQuests = tomQuest2.questsItems[desc].numQuests - 1
			if tomQuest2.questsItems[desc].numQuests == 0 then
				wipe(tomQuest2.questsItems[desc])
				tomQuest2.questsItems[desc] = nil
			end
		end
	elseif qType == "monster" then
		tomQuest2.questsMobs[desc].quests[uid] = nil
		tomQuest2.questsMobs[desc].numQuests = tomQuest2.questsMobs[desc].numQuests - 1
		if tomQuest2.questsMobs[desc].numQuests == 0 then
			wipe(tomQuest2.questsMobs[desc])
			tomQuest2.questsMobs[desc] = nil
		end
	end
	wipe(tomQuest2.questsObjectives[uid][objective])
	tomQuest2.questsObjectives[uid][objective] = nil
end

function tomQuest2:removePartyFromQuest(sender, uid, abandoning)
	self.quests[uid].playersOnQuest = self.quests[uid].playersOnQuest - 1
	self.quests[uid].complete[sender] = nil
	if self.quests[uid].playersOnQuest == 0 then
		if self.quests[uid].numObjectives > 0 then
			for objective, qoData in pairs(self.questsObjectives[uid]) do
				removeQuestObjective(uid, objective)
			end
			self.questsObjectives[uid] = nil
		end
		local zone = self.db.profile.quests.partyHeader and partyZone or self.quests[uid].zone
		self.questsByZone[zone][uid] = nil
		self.zones[zone].numQuests = self.zones[zone].numQuests - 1
		if self.zones[zone].numQuests == 0 then
			wipe(self.zones[zone])
			self.zones[zone] = nil
			wipe(self.questsByZone[zone])
			self.questsByZone[zone] = nil
			wipe(self.sortedQuestsByZone[zone])
			self.sortedQuestsByZone[zone] = nil
			zonesSort()
		end
		wipe(self.quests[uid])
		self.quests[uid] = nil
		questsSort()
	else
		if self.quests[uid].numObjectives > 0 then
			for objective, qoData in pairs(self.questsObjectives[uid]) do
				self.questsObjectives[uid][objective].got[sender] = nil
				self.questsObjectives[uid][objective].nGot[sender] = nil
				computeQuestObjectiveStatus(self, uid, objective)
			end
		end
		computeQuestStatus(self, uid)
	end
end

-----------------------
--- CHAT_MSG_SYSTEM ---
-----------------------
function tomQuest2:CHAT_MSG_SYSTEM(event, message)
	if message == NO_DAILY_QUESTS_REMAINING then
		self.numCompletedDailyQuests = self.maxDaily
		self.cbh:Fire("updateDailyCounter")
	else
		local remaining = message:match(dailyCounterPattern)
		if remaining then
			self.numCompletedDailyQuests = self.maxDaily - remaining
			self.cbh:Fire("updateDailyCounter")
			if remaining == 25 and self.db.profile.dailyList then
				for quest in pairs(self.db.profile.dailyList[self.playerName].dailies) do
					self.db.profile.dailyList[self.playerName].dailies[quest] = nil
				end
			end
		end
	end
end

------------------------
--- QUEST_LOG_UPDATE ---
------------------------
local tags = {
	[DAILY] = "daily",
	[GROUP] = "group",
	[ELITE] = "elite",
	[PVP] = "pvp",
	[DUNGEON] = "dungeon",
	[HEROIC] = "heroic",
	[tomQuest2.LC["Escort"]] = "escort",
	[""] = "notag",
}

local parseObjective = {
	item = function(description, done)
		local desc, got, need = description:match(objectsPattern)
		return desc, got, need, tonumber(got), tonumber(need), "object"
	end,
	object = function(description, done)
		local desc, got, need = description:match(objectsPattern)
		return desc, got, need, tonumber(got), tonumber(need), "object"
	end,
	monster = function(description, done)
		local desc, got, need = description:match(monstersPattern)
		if desc == nil or got == nil or need == nil then
			desc, got, need = description:match(objectsPattern)
		end
		return desc, got, need, tonumber(got), tonumber(need), "monster"
	end,
	reputation = function(description, done)
		local desc, got, need = description:match(factionPattern)
		return desc, got, need, tomQuest2.reactions[got], tomQuest2.reactions[need], "reputation"
	end,
	log = function(description, done)
		if done then
			return description, 1, 1, 1, 1, "log"
		else
			return description, 0, 1, 0, 1, "log"
		end
	end,
	event = function(description, done)
		if done then
			return description, 1, 1, 1, 1, "event"
		else
			return description, 0, 1, 0, 1, "event"
		end
	end,
	player = function(description, done)
		local faction = UnitFactionGroup("player")
		local got, need = description:match(playersPattern)
		if faction == "Alliance" then
			return tomQuest2.LC["Horde player killed"], got, need, tonumber(got), tonumber(need), "player"
		else
			return tomQuest2.LC["Alliance player killed"], got, need, tonumber(got), tonumber(need), "player"
		end
	end,
}

local function updateQuestLog(self, elapsed)
	self.duration = self.duration + elapsed
	if self.duration >= 0.1 then
		self.duration = 0
		tomQuest2:QUEST_LOG_UPDATE()
	end
end
local questLogUpdateFrame = CreateFrame("frame", "tomQuest2QuestLogUpdateFrame")
questLogUpdateFrame.duration = 0
questLogUpdateFrame:SetScript("OnUpdate", updateQuestLog)
questLogUpdateFrame:Hide()

function tomQuest2:QUEST_LOG_UPDATE(event)
	if questLogUpdating then
		return questLogUpdateFrame:Show()
	end
	questLogUpdateFrame:Hide()
	questLogNeedUpdate = nil
	questLogUpdating = true
	local selectionId = GetQuestLogSelection()
	local timeStamp = GetTime()
	self.numCompletedQuests = 0
	self.numEntries, self.numQuests = GetNumQuestLogEntries()
	local zone
	for id = 1, self.numEntries do
		local title, level, tag, group, header, collapsed, completed, daily, uid = GetQuestLogTitle(id)
		if header then
			zone = title
			if collapsed then
				self.collapsedHeader[zone] = true
			elseif self.collapsedHeader[zone] then
				self.collapsedHeader[zone] = nil
			end
			if not self.zones[zone] then
				addZone(zone)
				if not self.firstRun then
					zonesSort()
				end
			end
		else
			level, tag, group, daily = level or 0, tag or "", group or 0, daily or 0
			if not self.quests[uid] then
				self.questsTitleToUid[title] = uid
				if tags[tag] then
					tag = tags[tag]
				elseif tag == RAID then
					tag = "raid"
					group = LibTourist:GetInstanceGroupSize(zone) or group
				elseif tag:find(RAID) then
					tag = "raid"
					group = tonumber(tag:match("%d+")) or group
				else
					tag = "notag"
					self:Print("tag ["..tag.."] is missing for quest ["..uid.."] please report to tomQuest2 author on WOWAce or WOWInterface")
				end
				local numObjectives = GetNumQuestLeaderBoards(id) or 0
				addQuest(uid, title, level, tag, group, daily, numObjectives, zone)
				self.quests[uid].playersOnQuest = self.quests[uid].playersOnQuest + 1
				self.questsByZone[zone][uid] = true
				self.zones[zone].numQuests = self.zones[zone].numQuests + 1
				if zone == self.localClass then
					self.quests[uid].class = true
				end
				if not completed then
					if numObjectives == 0 then
						self.numCompletedQuests = self.numCompletedQuests + 1
						self.quests[uid].playerComplete = 1
						self.quests[uid].partyComplete = 1
						self.quests[uid].pqStatus = self.completedString
						self.quests[uid].complete[self.playerName] = 1
					else
						self.quests[uid].playerComplete = 0
						self.quests[uid].partyComplete = 0
						self.quests[uid].pqStatus = ""
						self.quests[uid].complete[self.playerName] = 0
					end
				elseif completed == 1 then
					self.numCompletedQuests = self.numCompletedQuests + 1
					self.quests[uid].playerComplete = 1
					self.quests[uid].partyComplete = 1
					self.quests[uid].pqStatus = self.completedString
					self.quests[uid].complete[self.playerName] = 1
				elseif completed == - 1 then
					self.quests[uid].playerComplete = 0
					self.quests[uid].partyComplete = 0
					self.quests[uid].pqStatus = self.failedString
					self.quests[uid].complete[self.playerName] = -1
				end
				if not self.firstRun then
					questsSort()
					self.cbh:Fire("addPlayerQuest", "q", uid, title, level, tag, group, daily, numObjectives, self.quests[uid].complete[self.playerName], zone)
				end
			elseif not self.quests[uid].complete[self.playerName] then
				self.questsTitleToUid[title] = uid
				self.quests[uid].playersOnQuest = self.quests[uid].playersOnQuest + 1
				if self.db.profile.quests.partyHeader then
					self.questsByZone[zone][uid] = true
					self.zones[zone].numQuests = self.zones[zone].numQuests + 1
					self.questsByZone[partyZone][uid] = nil
					self.zones[partyZone].numQuests = self.zones[partyZone].numQuests - 1
					if self.zones[partyZone].numQuests == 0 then
						wipe(self.zones[partyZone])
						self.zones[partyZone] = nil
						wipe(self.questsByZone[partyZone])
						self.questsByZone[partyZone] = nil
						wipe(self.sortedQuestsByZone[partyZone])
						self.sortedQuestsByZone[partyZone] = nil
						zonesSort()
					end
					questsSort()
				end
				if zone == self.localClass then
					self.quests[uid].class = true
				end
				if not completed then
					if self.quests[uid].numObjectives == 0 then
						self.numCompletedQuests = self.numCompletedQuests + 1
						self.quests[uid].playerComplete = 1
						if self.quests[uid].pqStatus ~= "" then
							self.quests[uid].pqStatus = self.quests[uid].pqStatus.." ,"..self.completedString
						else
							self.quests[uid].pqStatus = self.completedString
						end
						self.quests[uid].complete[self.playerName] = 1
					else
						self.quests[uid].playerComplete = 0
						self.quests[uid].partyComplete = 0
						self.quests[uid].complete[self.playerName] = 0
					end
				elseif completed == 1 then
					self.numCompletedQuests = self.numCompletedQuests + 1
					self.quests[uid].playerComplete = 1
					if self.quests[uid].pqStatus ~= "" then
						self.quests[uid].pqStatus = self.quests[uid].pqStatus.." ,"..self.completedString
					else
						self.quests[uid].pqStatus = self.completedString
					end
					self.quests[uid].complete[self.playerName] = 1
				elseif completed == -1 then
					self.quests[uid].playerComplete = 0
					self.quests[uid].partyComplete = 0
					if self.quests[uid].pqStatus ~= "" then
						self.quests[uid].pqStatus = self.quests[uid].pqStatus.." ,"..self.failedString
					else
						self.quests[uid].pqStatus = self.failedString
					end
					self.quests[uid].complete[self.playerName] = -1
				end
				self.cbh:Fire("addPlayerQuest", "q", uid, title, level, tag, group, daily, self.quests[uid].numObjectives, self.quests[uid].complete[self.playerName], zone)
			else
				if not completed then
					if self.quests[uid].numObjectives == 0 then
						self.numCompletedQuests = self.numCompletedQuests + 1
					elseif self.quests[uid].complete[self.playerName] == 1 then
						self.quests[uid].complete[self.playerName] = 0
						computeQuestStatus(self, uid)
						self.cbh:Fire("playerQuestUnComplete", "a", uid)
					end
				elseif completed == 1 then
					self.numCompletedQuests = self.numCompletedQuests + 1
					if self.quests[uid].complete[self.playerName] == 0 then
						self.quests[uid].complete[self.playerName] = 1
						computeQuestStatus(self, uid)
						self.cbh:Fire("playerQuestComplete", "c", uid)
					end
				elseif completed == -1 then
					if self.quests[uid].complete[self.playerName] ~= -1 then
						self.quests[uid].complete[self.playerName] = -1
						computeQuestStatus(self, uid)
						self.cbh:Fire("playerQuestFailed", "f", uid)
					end
				end
			end
			self.quests[uid].id = id
			self.quests[uid].timeStamp = timeStamp
			local started = 0
			local objKO
			for objective = 1, self.quests[uid].numObjectives do
				local description, qType, done = GetQuestLogLeaderBoard(objective, id)
				if qType and description then
					if parseObjective[qType] then
						local desc, got, need, nGot, nNeed, qT = parseObjective[qType](description, done)
						if not desc or strtrim(desc) == "" then
							objKO = true
							questLogNeedUpdate = true
						else
							if uid and objective and self.questsObjectives[uid] then
								if not self.questsObjectives[uid][objective] then
									addQuestObjective(uid, objective, desc, qT, need, nNeed)
									self.questsObjectives[uid][objective].got[self.playerName] = got
									self.questsObjectives[uid][objective].nGot[self.playerName] = nGot
									if nGot == nNeed then
										self.questsObjectives[uid][objective].playerComplete = 1
										self.questsObjectives[uid][objective].partyComplete = 1
										self.questsObjectives[uid][objective].qoColor = getColorFromCompletionHEX(1)
										self.questsObjectives[uid][objective].qoStatus = "|cff"..self.questsObjectives[uid][objective].qoColor..self.LC["d"].."/"..need.."|r"
										self.questsObjectives[uid][objective].qoStatusNC = self.LC["d"].."/"..need
									else
										self.questsObjectives[uid][objective].playerComplete = 0
										self.questsObjectives[uid][objective].partyComplete = 0
										self.questsObjectives[uid][objective].qoColor = getColorFromCompletionHEX(nGot/nNeed)
										self.questsObjectives[uid][objective].qoStatus = "|cff"..self.questsObjectives[uid][objective].qoColor..got.."/"..need.."|r"
										self.questsObjectives[uid][objective].qoStatusNC = got.."/"..need
									end
									if not self.firstRun then
										self.cbh:Fire("addPlayerQuestObjective", "o", uid, objective, desc, qT, got, need, nGot, nNeed)
									end
									if nGot ~= 0 then started = 1 end
								elseif not self.questsObjectives[uid][objective].nGot[self.playerName] then
									self.questsObjectives[uid][objective].got[self.playerName] = got
									self.questsObjectives[uid][objective].nGot[self.playerName] = nGot
									computeQuestObjectiveStatus(self, uid, objective)
									if not self.firstRun then
										self.cbh:Fire("addPlayerQuestObjective", "o", uid, objective, desc, qT, got, need, nGot, nNeed)
									end
									if nGot ~= 0 then started = 1 end
								elseif self.questsObjectives[uid][objective].nGot[self.playerName] ~= nGot then
									self.questsObjectives[uid][objective].got[self.playerName] = got
									self.questsObjectives[uid][objective].nGot[self.playerName] = nGot
									if self.quests[uid].playersOnQuest == 1 then
										if nGot == nNeed then
											self.questsObjectives[uid][objective].playerComplete = 1
											self.questsObjectives[uid][objective].partyComplete = 1
											self.questsObjectives[uid][objective].qoColor = getColorFromCompletionHEX(1)
											self.questsObjectives[uid][objective].qoStatus = "|cff"..self.questsObjectives[uid][objective].qoColor..self.LC["d"].."/"..need.."|r"
											self.questsObjectives[uid][objective].qoStatusNC = self.LC["d"].."/"..need
										else
											self.questsObjectives[uid][objective].playerComplete = 0
											self.questsObjectives[uid][objective].partyComplete = 0
											self.questsObjectives[uid][objective].qoColor = getColorFromCompletionHEX(nGot/nNeed)
											self.questsObjectives[uid][objective].qoStatus = "|cff"..self.questsObjectives[uid][objective].qoColor..got.."/"..need.."|r"
											self.questsObjectives[uid][objective].qoStatusNC = got.."/"..need
										end
									else
										computeQuestObjectiveStatus(self, uid, objective)
									end
									self.cbh:Fire("playerQuestObjectiveProgress", "p", uid, objective, got, nGot)
								end
							else
								self:Print("problem with questObjective please report the following")
								self:Print("uid ["..(uid or 0).."] objective ["..objective.."]")
								if not self.questsObjectives[uid] then
									self:Print("qO table missing")
								end
							end
						end
					else
						self:Print("objective type ["..qType.."] unknown for objective ["..description.."] and quest ["..uid.."] please report to tomQuest2 author on WOWAce or WOWInterface")
					end
				else
					objKO = true
					questLogNeedUpdate = true
				end
			end
			if not objKO then
				if not self.quests[uid].extras then
					SelectQuestLogEntry(id)
					self.quests[uid].description, self.quests[uid].objective = GetQuestLogQuestText()
					if not self.quests[uid].description or not self.quests[uid].objective then
						questLogUpdateFrame:Show()
					else
						self.quests[uid].extras = true
					end
					local itemLink, itemIcon, itemCharges = GetQuestLogSpecialItemInfo(id)
					if itemLink then
						local _, item = strsplit(":", itemLink or "")
						self.quests[uid].specialItemLink, self.quests[uid].specialItemIcon, self.quests[uid].specialItemCharges = item, itemIcon, itemCharges
						if items[self.quests[uid].specialItemLink] and items[self.quests[uid].specialItemLink] ~= uid then
							if items[self.quests[uid].specialItemLink] == 0 then
								self.numItemsStartingQuest = self.numItemsStartingQuest - 1
								wipe(self.itemStartingQuest[self.quests[uid].specialItemLink])
								self.itemStartingQuest[self.quests[uid].specialItemLink] = nil
							elseif items[self.quests[uid].specialItemLink] == -1 then
								self.numUsableQuestItems = self.numUsableQuestItems - 1
								wipe(self.usableQuestItems[self.quests[uid].specialItemLink])
								self.usableQuestItems[self.quests[uid].specialItemLink] = nil
							end
						end
						self.quests[uid].itemHasRange = ItemHasRange(self.quests[uid].specialItemLink)
						self.quests[uid].item = true
						items[self.quests[uid].specialItemLink] = uid
					end
					self.quests[uid].sharable = GetQuestLogPushable()
					self.quests[uid].money = GetQuestLogRewardMoney() or 0
					self.quests[uid].honor = GetQuestLogRewardHonor() or 0
					self.quests[uid].talent = GetQuestLogRewardTalents() or 0
					self.quests[uid].titleReward = GetQuestLogRewardTitle() or ""
					local numRewards = GetNumQuestLogRewards() or 0
					local numChoices = GetNumQuestLogChoices() or 0
					self.quests[uid].numRewards, self.quests[uid].numChoices = numRewards, numChoices
					local rewardSpellTexture, rewardSpellName = GetQuestLogRewardSpell()
					self.quests[uid].rewardSpellTexture = rewardSpellTexture or ""
					self.quests[uid].rewardSpellName = rewardSpellName or ""
					if numRewards > 0 then
						self.quests[uid].itemRewards = {}
						for i = 1, numRewards do
							self.quests[uid].itemRewards[i] = {}
							self.quests[uid].itemRewards[i].name, self.quests[uid].itemRewards[i].texture, self.quests[uid].itemRewards[i].numItems, self.quests[uid].itemRewards[i].quality, self.quests[uid].itemRewards[i].isUsable = GetQuestLogRewardInfo(i)
							self.quests[uid].itemRewards[i].link = GetQuestLogItemLink("reward", i)
						end
					end
					if numChoices > 0 then
						self.quests[uid].itemChoices = {}
						for i = 1, numChoices do
							self.quests[uid].itemChoices[i] = {}
							self.quests[uid].itemChoices[i].name, self.quests[uid].itemChoices[i].texture, self.quests[uid].itemChoices[i].numItems, self.quests[uid].itemChoices[i].quality, self.quests[uid].itemChoices[i].isUsable = GetQuestLogChoiceInfo(i)
							self.quests[uid].itemChoices[i].link = GetQuestLogItemLink("choice", i)
						end
					end
					if self.usableQuestItems then
						for itemLink, itemData in pairs(self.usableQuestItems) do
							if (self.quests[uid].objective and self.quests[uid].objective:find(itemData.name, 1, true)) or (self.quests[uid].description and self.quests[uid].description:find(itemData.name, 1, true)) then
								items[itemLink] = uid
								self.quests[uid].specialItemLink, self.quests[uid].specialItemIcon = itemLink, itemData.icon
								self.numUsableQuestItems = self.numUsableQuestItems - 1
								wipe(self.usableQuestItems[itemLink])
								self.usableQuestItems[itemLink] = nil
							end
						end
					end
					if self.itemStartingQuest then
						for itemLink, itemData in pairs(self.itemStartingQuest) do
							if (self.quests[uid].objective and self.quests[uid].objective:find(itemData.name, 1, true)) or (self.quests[uid].description and self.quests[uid].description:find(itemData.name, 1, true)) then
								items[itemLink] = uid
								self.quests[uid].specialItemLink, self.quests[uid].specialItemIcon = itemLink, itemData.icon
								self.numItemsStartingQuest = self.numItemsStartingQuest - 1
								wipe(self.itemStartingQuest[itemLink])
								self.itemStartingQuest[itemLink] = nil
							end
						end
					end
					local initialTimer = GetQuestLogTimeLeft()
					if initialTimer then
						self.quests[uid].initialTimer = initialTimer
						self.quests[uid].startTime = GetTime()
					end
				end
				if self.firstRun then
					self.quests[uid].sync = true
				elseif not self.quests[uid].sync then
					self.quests[uid].sync = true
					self.cbh:Fire("playerQuestAccepted", "r", uid, started)
				end
			end
		end
	end
	if GetQuestLogSelection() ~= selectionId then
		SelectQuestLogEntry(selectionId)
	end
	if not self.firstRun then
		for uid, qData in pairs(self.quests) do
			if qData.complete[self.playerName] and qData.timeStamp ~= timeStamp then
				if not self.collapsedHeader[qData.zone] then
					local daily = self.quests[uid].daily
					local title = self.quests[uid].title
					self.questsTitleToUid[title] = nil
					self.quests[uid].playersOnQuest = self.quests[uid].playersOnQuest - 1
					self.quests[uid].complete[self.playerName] = nil
					if self.currentUidMacro == uid and not InCombatLockdown() then
						self.currentUidMacro = nil
						local index = GetMacroIndexByName("tomQuest2_SI")
						if index ~= 0 then
							EditMacro(index, "tomQuest2_SI", 1, "")
						end
					end
					self.quests[uid].id = nil
					if self.quests[uid].playersOnQuest == 0 then
						if self.quests[uid].numObjectives > 0 then
							for objective, qoData in pairs(self.questsObjectives[uid]) do
								removeQuestObjective(uid, objective)
							end
						end
						self.questsObjectives[uid] = nil
						local zone = self.quests[uid].zone
						self.zones[zone].numQuests = self.zones[zone].numQuests - 1
						self.questsByZone[zone][uid] = nil
						if self.zones[zone].numQuests == 0 then
							wipe(self.zones[zone])
							self.zones[zone] = nil
							wipe(self.questsByZone[zone])
							self.questsByZone[zone] = nil
							wipe(self.sortedQuestsByZone[zone])
							self.sortedQuestsByZone[zone] = nil
							zonesSort()
						end
						wipe(self.quests[uid])
						self.quests[uid] = nil
						questsSort()
					else
						if self.quests[uid].numObjectives > 0 then
							for objective, qoData in pairs(self.questsObjectives[uid]) do
								self.questsObjectives[uid][objective].got[self.playerName] = nil
								self.questsObjectives[uid][objective].nGot[self.playerName] = nil
								computeQuestObjectiveStatus(self, uid, objective)
							end
						end
						if self.db.profile.quests.partyHeader then
							local zone = self.quests[uid].zone
							self.zones[zone].numQuests = self.zones[zone].numQuests - 1
							if self.zones[zone].numQuests == 0 then
								wipe(self.zones[zone])
								self.zones[zone] = nil
								wipe(self.questsByZone[zone])
								self.questsByZone[zone] = nil
								wipe(self.sortedQuestsByZone[zone])
								self.sortedQuestsByZone[zone] = nil
								if not self.questsByZone[partyZone] then
									addZone(partyZone)
								end
								zonesSort()
							else
								self.questsByZone[zone][uid] = nil
								if not self.questsByZone[partyZone] then
									addZone(partyZone)
									zonesSort()
								end
							end
							self.questsByZone[partyZone][uid] = true
							self.zones[partyZone].numQuests = self.zones[partyZone].numQuests + 1
							questsSort()
						end
						computeQuestStatus(self, uid)
					end
					self.cbh:Fire("playerQuestLost", "l", uid, self.abandoning)
					if daily == 1 and not self.abandoning and self.numCompletedDailyQuests > 0 then
						if not self.db.profile.dailyList[self.playerName] then
							self.db.profile.dailyList[self.playerName] = {}
							self.db.profile.dailyList[self.playerName].class = self.playerClass
							self.db.profile.dailyList[self.playerName].dailies = {}
						end
						self.db.profile.dailyList[self.playerName].dailies[title] = time()
					end
				else
					self.quests[uid].id = nil
				end
			end
		end
		if questLogNeedUpdate then
			questLogUpdateFrame:Show()
		end
	else
		if questLogNeedUpdate then
			questLogUpdateFrame:Show()
		else
			zonesSort()
			questsSort()
			self:PARTY_MEMBERS_CHANGED()
			self.cbh:Fire("init")
			self.firstRun = nil
			self:BAG_UPDATE()
			self:RegisterEvent("BAG_UPDATE")
		end
	end
	self.cbh:Fire("questLogUpdated", true, true)
	self.abandoning = nil
	questLogUpdating = nil
end

-----------------------
--- PLAYER_LEVEL_UP ---
-----------------------
function tomQuest2:PLAYER_LEVEL_UP(event, newPlayerLevel)
	self.playerLevel = newPlayerLevel
	if self.playerLevel == MAX_PLAYER_LEVEL then
		self:UnregisterEvent("PLAYER_LEVEL_UP")
	end
	for zone, zData in pairs(self.zones) do
		if zData.minLevel ~= 0 then
			local r, g, b = LibTourist:GetLevelColor(zone)
			self.zones[zone].color = format("%02x%02x%02x", r*255, g*255, b*255)
		end
	end
	for uid, qData in pairs(self.quests) do
		local qc = getDifficultyColor(qData.level - self.playerLevel)
		self.quests[uid].color = format("%02x%02x%02x", qc.r*255, qc.g*255, qc.b*255)
	end
	self.cbh:Fire("questLogUpdated", false, true)
	questsSort()
end

------------------
--- BAG_UPDATE ---
------------------
local function findItemOnUse(itemLink)
	scanTooltipTQ2:ClearLines()
	scanTooltipTQ2:SetOwner(WorldFrame, "ANCHOR_NONE")
	scanTooltipTQ2:SetHyperlink(itemLink)
	scanTooltipTQ2:Show()
	for _, lineNum in pairs(scanTooltipLines) do
		local text = _G[lineNum]:GetText()
		if text and sub(text, 1, itemUseLen) == ITEM_SPELL_TRIGGER_ONUSE then
			scanTooltipTQ2:Hide()
			return true
		end
	end
	scanTooltipTQ2:Hide()
	return false
end

local function findItemStartingQuest(itemLink)
	scanTooltipTQ2:ClearLines()
	scanTooltipTQ2:SetOwner(WorldFrame, "ANCHOR_NONE")
	scanTooltipTQ2:SetHyperlink(itemLink)
	scanTooltipTQ2:Show()
	for _, lineNum in pairs(scanTooltipLines) do
		local text = _G[lineNum]:GetText()
		if text and text == ITEM_STARTS_QUEST then
			scanTooltipTQ2:Hide()
			return true
		end
	end
	scanTooltipTQ2:Hide()
	return false
end

local function analyseItem(item, itemLink, batch)
	local itemName, _, itemRarity, _, _, itemType, _, _, _, itemTexture = GetItemInfo(item)
	if itemType == tomQuest2.LC["Quest"] then
		local itemSpell = GetItemSpell(item)
		if itemSpell or findItemOnUse(itemLink) then
			for uid, qData in pairs (tomQuest2.quests) do
				if qData.complete[tomQuest2.playerName] and ((qData.objective and qData.objective:find(itemName, 1, true)) or (qData.description and qData.description:find(itemName, 1, true))) then
					items[item] = uid
					tomQuest2.quests[uid].specialItemLink, tomQuest2.quests[uid].specialItemIcon = item, itemTexture
					return true
				end
			end
			items[item] = -1
			tomQuest2.usableQuestItems[item] = {}
			local color = tomQuest2.rarityColor[itemRarity]
			tomQuest2.usableQuestItems[item].icon, tomQuest2.usableQuestItems[item].color, tomQuest2.usableQuestItems[item].name = itemTexture, color, itemName
			tomQuest2.numUsableQuestItems = tomQuest2.numUsableQuestItems + 1
			return true
		elseif findItemStartingQuest(itemLink) then
			items[item] = 0
			tomQuest2.itemStartingQuest[item] = {}
			local color = tomQuest2.rarityColor[itemRarity]
			tomQuest2.itemStartingQuest[item].icon, tomQuest2.itemStartingQuest[item].color, tomQuest2.itemStartingQuest[item].name = itemTexture, color, itemName
			tomQuest2.numItemsStartingQuest = tomQuest2.numItemsStartingQuest + 1
			if not tomQuest2.firstRun then
				tomQuest2.cbh:Fire("itemStartingQuestLooted", item)
			end
			return true
		end
	elseif specialItems[item] then
		items[item] = -1
		tomQuest2.usableQuestItems[item] = {}
		local color = tomQuest2.rarityColor[itemRarity]
		tomQuest2.usableQuestItems[item].icon, tomQuest2.usableQuestItems[item].color, tomQuest2.usableQuestItems[item].name = itemTexture, color, itemName
		tomQuest2.numUsableQuestItems = tomQuest2.numUsableQuestItems + 1
		return true
	elseif findItemStartingQuest(itemLink) then
		items[item] = 0
		tomQuest2.itemStartingQuest[item] = {}
		local color = tomQuest2.rarityColor[itemRarity]
		tomQuest2.itemStartingQuest[item].icon, tomQuest2.itemStartingQuest[item].color, tomQuest2.itemStartingQuest[item].name = itemTexture, color, itemName
		tomQuest2.numItemsStartingQuest = tomQuest2.numItemsStartingQuest + 1
		if not tomQuest2.firstRun then
			tomQuest2.cbh:Fire("itemStartingQuestLooted", item)
		end
		return true
	else
		items[item] = -2
		return false
	end
end

local function bagBucket(self, elapsed)
	self.duration = self.duration + elapsed
	if self.duration >= 1 then
		self.duration = 0
		self:Hide()
		local timeStamp = GetTime()
		local updateQuestsTracker
		for bag = 0, 4 do
			for slot = 1, GetContainerNumSlots(bag) do
				local itemLink = GetContainerItemLink(bag, slot)
				if itemLink then
					local _, item = strsplit(":", itemLink)
					itemsTimeStamp[item] = timeStamp
					if not items[item] then
						local update = analyseItem(item, itemLink, true)
						if update then updateQuestsTracker = true end
					end
				end
			end
		end
		for slotId in pairs(inventorySlotId) do
			local itemLink = GetInventoryItemLink("player", slotId)
			if itemLink then
				local _, item = strsplit(":", itemLink)
				itemsTimeStamp[item] = timeStamp
				if not items[item] then
					local update = analyseItem(item, itemLink, false)
					if update then updateQuestsTracker = true end
				end
			end
		end
		for item in pairs(itemsTimeStamp) do
			if itemsTimeStamp[item] ~= timeStamp then
				itemsTimeStamp[item] = nil
				if items[item] then
					if items[item] == 0 then
						wipe(tomQuest2.itemStartingQuest[item])
						tomQuest2.itemStartingQuest[item] = nil
						tomQuest2.numItemsStartingQuest = tomQuest2.numItemsStartingQuest - 1
						updateQuestsTracker = true
						items[item] = nil
					elseif items[item] == -1 then
						wipe(tomQuest2.usableQuestItems[item])
						tomQuest2.usableQuestItems[item] = nil
						tomQuest2.numUsableQuestItems = tomQuest2.numUsableQuestItems - 1
						updateQuestsTracker = true
						items[item] = nil
					elseif items[item] == -2 then
						items[item] = nil
					end
				end
			end
		end
		if updateQuestsTracker then
			tomQuest2.cbh:Fire("updateQuestsTracker")
		end
	end
end
local bagBucketFrame = CreateFrame("frame", "tomQuest2BagBucketFrame")
bagBucketFrame.duration = 0
bagBucketFrame:SetScript("OnUpdate", bagBucket)
bagBucketFrame:Hide()

function tomQuest2:BAG_UPDATE()
	bagBucketFrame:Show()
end

--------------------------------
--- displayQuestInformations ---
--------------------------------
function tomQuest2:displayQuestInformations(uid)
	if self.db.profile.modules["informations"] then
		self.cbh:Fire("displayQuestInformations", uid)
	elseif not self.db.profile.modules["informations"] and self.quests[uid] and self.quests[uid].id then
		QuestLog_OpenToQuest(self.quests[uid].id)
	end
end

------------------------
--- Macro Generation ---
------------------------
function tomQuest2:generateSpecialItemMacro(uid, item)
	if uid and self.quests[uid].id and self.quests[uid].specialItemLink then
		self.currentUidMacro = uid
		self.currentItemMacro = nil
		if InCombatLockdown() then return end
		local _, itemLink = GetItemInfo(self.quests[uid].specialItemLink)
		local found, _, itemString = find(itemLink, "^|c%x+|H(.+)|h%[.*%]")
		local index = GetMacroIndexByName("tomQuest2_SI")
		if index == 0 then
			index = CreateMacro("tomQuest2_SI", 1, "#showtooltip\n/use "..itemString, 0)
			PickupMacro(index)
		else
			EditMacro(index, "tomQuest2_SI", 1, "#showtooltip\n/use "..itemString)
		end
	elseif item and items[item] then
		self.currentUidMacro = nil
		self.currentItemMacro = item
		if InCombatLockdown() then return end
		local _, itemLink = GetItemInfo(item)
		local found, _, itemString = find(itemLink, "^|c%x+|H(.+)|h%[.*%]")
		local index = GetMacroIndexByName("tomQuest2_SI")
		if index == 0 then
			index = CreateMacro("tomQuest2_SI", 1, "#showtooltip\n/use "..itemString, 0)
			PickupMacro(index)
		else
			EditMacro(index, "tomQuest2_SI", 1, "#showtooltip\n/use "..itemString)
		end
	end
end

local optionFrame = CreateFrame("Frame", nil, InterfaceOptionsFrameAddOns)
local function loadConfigGUI()
	optionFrame:SetScript("OnShow", nil)
	LoadAddOn("tomQuest2_Config")
end
optionFrame:SetScript("OnShow", loadConfigGUI)

--------------------------
--- Keybinding globals ---
--------------------------
BINDING_HEADER_TOMQUEST2 = "tomQuest2"